﻿
using System;
using System.Collections.Generic;
using System.Windows.Forms;
using Gecko;
using GeckoFX;

namespace b4pGeckoFX
{

	public class GeckoWebBrowser 
	{
		private Gecko.GeckoWebBrowser browser;

		private object[] DocumentCompletedObject;
		public event EventHandler DocumentCompleted;
		
		public GeckoWebBrowser(Form ParentForm, string xulrunnerPath,int left, int top, int width, int height)
		{
			Xpcom.Initialize(xulrunnerPath);
			browser = new Gecko.GeckoWebBrowser();
			browser.Left = left;
        	browser.Top = top;
        	browser.Width = width;
        	browser.Height = height;
         	
        	
        	
        	DocumentCompletedObject = new object[] {this,"DocumentCompleted"};
        	browser.DocumentCompleted += new EventHandler(browser_DocumentCompleted);       
        	
        	
        	
        	
        	
        	ParentForm.Controls.Add(browser);
		
		
		
		}
		
		
		
		//Methods
		
		public void Navigate(string url)
        {
        	browser.Navigate(url);
        	
        }
		
		        public void BringToFront(string url)
        {
        	browser.BringToFront();
        }
        
      
        
        public void Focus()
        {
        	browser.Focus();
        }
 
        
        
        public void Show()
        {
        	browser.Show();
        }
         public void Hide()
        {
         	browser.Hide();
         	
        }            
        
        public void Reload()
        {
        	browser.Reload();
        }        
         
        public void GoForward()
        {
        	browser.GoForward();
        }       
        
        public void GoBack()
        {
        	browser.GoBack();
        }         
       
        public void Stop()
        {
        	browser.Stop();
        }         
       
        public void Refresh()
        {
        	browser.Refresh();
        }        
        
        
        
        public void Redo()
        {
        	browser.Redo();
        }       
       
        public void Undo()
        {
        	browser.Undo();
        }        
        
        
        
 		public void Dispose()
		{
			browser.DocumentCompleted -= new EventHandler(DocumentCompleted);
			
			browser.Dispose();
			
			
		}       
        
        
        
        
        //Properties
        
        public int Width
		{
			get {return browser.Width;}
			set {browser.Width = value;}
		}
		
		public int Height
		{
			get {return browser.Height;}
			set {browser.Height = value;}
		}
      
		public int Left
		{
			get {return browser.Left;}
			set {browser.Left = value;}
		}		
		
		
		public int Top
		{
			get {return browser.Top;}
			set {browser.Top = value;}
		}		
		
		
		public string Document
		{
			get{return browser.Document.ToString();}
				
		}
		
		public Control ControlRef
		{
			get{return browser;}
		}
		

		
		public bool IsBusy
		{
			get{return browser.IsBusy;}			
		}	
		
		public string Url
		{
			get{return browser.Url.ToString();}
		}
		
		public bool Visible
		{
			get{return browser.Visible;}
			set{browser.Visible = value;}
		}
		
		
		
		
		//Events
		
		private void browser_DocumentCompleted(object sender, EventArgs e)
		{
		
			if(DocumentCompleted != null)
				DocumentCompleted(DocumentCompletedObject,null);
		
		}
		
		
		
	}
}